//
//  NSMutableDictionary+GHLCrashGuard.m
//  GHLCrashGuard
//
//  Created by 与佳期 on 2019/7/11.
//

#import "NSMutableDictionary+GHLCrashGuard.h"
#import "JRSwizzle.h"

@implementation NSMutableDictionary (GHLCrashGuard)

+ (void)load {
    
    [NSClassFromString(@"__NSDictionaryM") jr_swizzleMethod:@selector(removeObjectForKey:) withMethod:@selector(guard_removeObjectForKey:) error:nil];
    [NSClassFromString(@"__NSDictionaryM") jr_swizzleMethod:@selector(setObject:forKey:) withMethod:@selector(guard_setObject:forKey:) error:nil];
}

- (void)guard_removeObjectForKey:(id)aKey {
    if (!aKey) {
        [[self class] warningDeveloper:NSSelectorFromString([NSString stringWithFormat:@"%s",__FUNCTION__])];
        return;
    }
    [self guard_removeObjectForKey:aKey];
}

- (void)guard_setObject:(id)anObject forKey:(id <NSCopying>)aKey {
    if (!anObject) {
        [[self class] warningDeveloper:NSSelectorFromString([NSString stringWithFormat:@"%s",__FUNCTION__])];
        return;
    }
    if (!aKey) {
        [[self class] warningDeveloper:NSSelectorFromString([NSString stringWithFormat:@"%s",__FUNCTION__])];
        return;
    }
    [self guard_setObject:anObject forKey:aKey];
}

+ (void)warningDeveloper:(SEL)aSelector{
#if DEBUG
    
    NSString *selectorStr = NSStringFromSelector(aSelector);
    NSLog(@"PROTECTOR: -[%@ %@]", [self class], selectorStr);
    NSLog(@"PROTECTOR: unrecognized selector \"%@\" sent to instance: %p", selectorStr, self);
    NSLog(@"PROTECTOR: call stack: %@", [NSThread callStackSymbols]);
    NSAssert(NO, @"marr调用出错---[%@-%@]", [self class], selectorStr);
    // @throw @"方法找不到";
#endif
}
@end
